using Markdig.Renderers;
using Markdig.Renderers.Html;
using Markdig.Syntax;
using Markdig.Syntax.Inlines;
using System.Collections.Generic;

namespace Website.Markdig.Extensions
{
	public class BlogHeadingRenderer : HtmlObjectRenderer<HeadingBlock> {
		private readonly HeadingRenderer _baseRenderer;

		public BlogHeadingRenderer(HeadingRenderer baseRenderer) {
			_baseRenderer = baseRenderer;
		}

		protected override void Write(HtmlRenderer renderer, HeadingBlock heading) {
			var htmlAttributes = heading.GetAttributes();
			if (htmlAttributes.Properties == null)
				htmlAttributes.Properties = new List<KeyValuePair<string, string>>();
			var id = (heading.Inline.FirstChild as LiteralInline).Content.ToString().ToLower().Replace(" ", "-");
			htmlAttributes.Properties.Add(new KeyValuePair<string, string>("id", id));
			_baseRenderer.Write(renderer, heading);
		}
	}
}