using Microsoft.Extensions.Caching.Memory;
using Robware.Lib.ApiClient;
using System.Collections.Generic;
using System.Net.Http;
using System.Threading.Tasks;
using Website.Models.ApiKey;

namespace Website.Data
{
	public class ApiKeyManager : ApiClient, IApiKeyManager
	{
		public ApiKeyManager(HttpClient client, IMemoryCache cache, CacheDurations cacheDurations) : base(client, cache, cacheDurations)
		{
		}
		
		public async Task<ApiKey> Create(string name) => await Post<ApiKey>("create", null, new{name});

		public async Task<IEnumerable<ApiKey>> List() => await Get<IEnumerable<ApiKey>>("list");

		public async Task Delete(string key) => await Delete<object>("delete", new {key});

		public async Task Enable(string key) => await Patch<object>("enable", null, new {key});

		public async Task Disable(string key) => await Patch<object>("disable", null, new {key});
	}
}